//-----------------------------------------------
// Copyright 2009 Wellcome Trust Sanger Institute
// Written by Jared Simpson (js18@sanger.ac.uk)
// Released under the GPL license
//-----------------------------------------------
import Alphabet;
import tango.util.collection.ArraySeq;
import tango.io.Stdout;

// Globals

// Column names
char[] DEPTH_COL_NAME = "depth";
char[] HET_COL_NAME = "het_rate";
char[] AVGHIT_COL_NAME = "avghit";

// State names
char[] SNAME_ZERO = "Z";
char[] SNAME_REPEAT = "R";
char[] SNAME_NORMAL = "N";
char[] SNAME_HALF = "C0.5";
char[] SNAME_C1 = "C1";
char[] SNAME_C2 = "C2";
char[] SNAME_C3 = "C3";

// Data structure definitions
struct InputData
{
	char[] chr;
	real pos; // Coordinate in megabases
	real snp_rate;
	real het_rate;
	real depth;
	real udepth; // Depth in "unique" regions
	real avg_hits; // average number of hits for reads falling in this range
	real gc_content;
}

//
// Simple collection of statistics
//
struct Statistics
{
	real mean;
	real median;
	real sd;
}

//
// The parameters a particular state can take
//
struct StateParameters
{
	real depth_mean;
	real depth_sd;
	real het_mean;
	real avghit_mean;

	char[] toString()
	{
		return "[" ~ Float.toString(depth_mean) ~ " " ~
				Float.toString(depth_sd) ~ " " ~
				Float.toString(het_mean) ~ " " ~
				Float.toString(avghit_mean) ~ "]";
	}
}

// Aliases
alias ArraySeq!(InputData) InputArray;
alias InputArray[char[]] StringInputArrayMap;
alias SymbolArray[char[]] StringSymbolArrayMap;
