//-----------------------------------------------
// Copyright 2009 Wellcome Trust Sanger Institute
// Written by Jared Simpson (js18@sanger.ac.uk)
// Released under the GPL license
//-----------------------------------------------
module State;

import Alphabet;
import Distribution;
import tango.util.collection.ArraySeq;

class State : Symbol
{
	//
	// Constructor
	//
	this(char[] name, IDistribution d)
	{
		super(name);
		m_emissionDist = d;
	}
	
	//
	// Get the weight of the symbol
	//
	real getWeight(Symbol s)
	{
		return getEmissionDistribution().getWeight(s);
	}

	//
	// Get the emission distribution
	//
	IDistribution getEmissionDistribution() { return m_emissionDist; }

	//
	// Set the emission distribution
	//
	void setEmissionDistribution(IDistribution d)
	{
		m_emissionDist = d;
	}
	
	//
	// Members
	//
	IDistribution m_emissionDist;
}

